// Generated by CoffeeScript 1.10.0
var EventEmitterGrouped, Suite, Task, TaskGroup, Test, isBrowser, isWindows, joe, joePrivate, ref, ref1, util,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  slice = [].slice;

util = require('util');

EventEmitterGrouped = require('event-emitter-grouped').EventEmitterGrouped;

ref = require('taskgroup/es2015'), Task = ref.Task, TaskGroup = ref.TaskGroup;

isBrowser = typeof window !== "undefined" && window !== null;

isWindows = (typeof process !== "undefined" && process !== null ? (ref1 = process.platform) != null ? ref1.indexOf('win') : void 0 : void 0) === 0;

Test = (function(superClass) {
  extend(Test, superClass);

  function Test() {
    return Test.__super__.constructor.apply(this, arguments);
  }

  Test.create = function() {
    var args;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return (function(func, args, ctor) {
      ctor.prototype = func.prototype;
      var child = new ctor, result = func.apply(child, args);
      return Object(result) === result ? result : child;
    })(this, args, function(){});
  };

  Test.isTest = function(test) {
    return test instanceof Test;
  };

  Test.prototype.setConfig = function() {
    var after, before, me;
    Test.__super__.setConfig.apply(this, arguments);
    me = this;
    if (before = this.config.before) {
      delete this.config.before;
      this.on('before', function(complete) {
        return before.call(this, me, complete);
      });
    }
    if (after = this.config.after) {
      delete this.config.after;
      this.on('after', function(complete) {
        return after.call(this, me, complete);
      });
    }
    return this;
  };

  Test.prototype.run = function() {
    if (!this.started) {
      this.emitSerial('before', (function(_this) {
        return function(err) {
          if (err) {
            _this.emit('error', err);
          }
          return Test.__super__.run.apply(_this, arguments);
        };
      })(this));
    } else {
      Test.__super__.run.apply(this, arguments);
    }
    return this;
  };


  /*
  	fire: ->
  		// Setup timeout if appropriate
  		const timeoutDuration = this.config.timeout
  		if ( timeoutDuration ) {
  			this.state.timeout = setTimeout(() => {
  				if ( !this.completed ) {
  					const error = new Error(`The task [${this.names}] has timed out.`)
  					exitMethod(error)
  				}
  			}, timeoutDuration)
  		}
   */

  Test.prototype.finish = function() {
    if (!this.exited) {
      this.emitSerial('after', (function(_this) {
        return function(err) {
          if (err) {
            _this.emit('error', err);
          }
          return Test.__super__.finish.apply(_this, arguments);
        };
      })(this));
    } else {
      Test.__super__.finish.apply(this, arguments);
    }
    return this;
  };

  return Test;

})(Task);

Suite = (function(superClass) {
  extend(Suite, superClass);

  Suite.create = function() {
    var args;
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return (function(func, args, ctor) {
      ctor.prototype = func.prototype;
      var child = new ctor, result = func.apply(child, args);
      return Object(result) === result ? result : child;
    })(this, args, function(){});
  };

  Suite.isSuite = function(suite) {
    return suite instanceof Suite;
  };

  function Suite() {
    var me, nestedListener;
    Suite.__super__.constructor.apply(this, arguments);
    me = this;
    this.on('item.add', function(item) {
      if (Test.isTest(item)) {
        item.on('running', function() {
          return me.testRunCallback(item);
        });
        item.done(function(err) {
          return me.testCompleteCallback(item, err);
        });
        item.on('before', function(complete) {
          return me.emitSerial('test.before', item, complete);
        });
        return item.on('after', function(complete) {
          return me.emitSerial('test.after', item, complete);
        });
      } else if (Suite.isSuite(item)) {
        item.on('running', function() {
          return me.suiteRunCallback(item);
        });
        item.done(function(err) {
          return me.suiteCompleteCallback(item, err);
        });
        item.on('before', function(complete) {
          return me.emitSerial('suite.before', item, complete);
        });
        return item.on('after', function(complete) {
          return me.emitSerial('suite.after', item, complete);
        });
      }
    });
    this.on('item.add', nestedListener = function(item) {
      if (Test.isTest(item)) {
        item.on('before', function(complete) {
          return me.emitSerial('nested.test.before', item, complete);
        });
        return item.on('after', function(complete) {
          return me.emitSerial('nested.test.after', item, complete);
        });
      } else if (Suite.isSuite(item)) {
        item.on('item.add', nestedListener);
        item.on('before', function(complete) {
          return me.emitSerial('nested.suite.before', item, complete);
        });
        return item.on('after', function(complete) {
          return me.emitSerial('nested.suite.after', item, complete);
        });
      }
    });
    this;
  }

  Suite.prototype.setConfig = function() {
    var after, before, me;
    Suite.__super__.setConfig.apply(this, arguments);
    me = this;
    if (before = this.config.before) {
      delete this.config.before;
      this.on('before', function(complete) {
        return before.call(this, me, complete);
      });
    }
    if (after = this.config.after) {
      delete this.config.after;
      this.on('after', function(complete) {
        return after.call(this, me, complete);
      });
    }
    return this;
  };

  Suite.prototype.run = function() {
    if (!this.started) {
      this.emitSerial('before', (function(_this) {
        return function(err) {
          if (err) {
            _this.emit('error', err);
          }
          return Suite.__super__.run.apply(_this, arguments);
        };
      })(this));
    } else {
      Suite.__super__.run.apply(this, arguments);
    }
    return this;
  };

  Suite.prototype.finish = function() {
    if (!this.exited) {
      this.emitSerial('after', (function(_this) {
        return function(err) {
          if (err) {
            _this.emit('error', err);
          }
          return Suite.__super__.finish.apply(_this, arguments);
        };
      })(this));
    } else {
      Suite.__super__.finish.apply(this, arguments);
    }
    return this;
  };

  Suite.prototype.addMethod = function(method, config) {
    if (config == null) {
      config = {};
    }
    if (config.reporting == null) {
      config.reporting = false;
    }
    if (config.name == null) {
      config.name = false;
    }
    if (config.args == null) {
      config.args = [this.suite.bind(this), this.test.bind(this)];
    }
    return Suite.__super__.addMethod.call(this, method, config);
  };

  Suite.prototype.suiteRunCallback = function(suite) {
    var config;
    config = suite.config;
    if (config.reporting !== false) {
      joePrivate.totalSuites++;
      return joe.report('startSuite', suite);
    }
  };

  Suite.prototype.suiteCompleteCallback = function(suite, err) {
    var config;
    config = suite.config;
    if (err) {
      joePrivate.addErrorLog({
        suite: suite,
        err: err
      });
      if (config.reporting !== false) {
        joePrivate.totalFailedSuites++;
      }
    } else {
      if (config.reporting !== false) {
        joePrivate.totalPassedSuites++;
      }
    }
    if (config.reporting !== false) {
      return joe.report('finishSuite', suite, err);
    }
  };

  Suite.prototype.testRunCallback = function(test) {
    var config;
    config = test.config;
    if (config.reporting !== false) {
      joePrivate.totalTests++;
      return joe.report('startTest', test);
    }
  };

  Suite.prototype.testCompleteCallback = function(test, err) {
    var config;
    config = test.config;
    if (err) {
      joePrivate.addErrorLog({
        test: test,
        err: err
      });
      if (config.reporting !== false) {
        joePrivate.totalFailedTests++;
      }
    } else {
      if (config.reporting !== false) {
        joePrivate.totalPassedTests++;
      }
    }
    if (config.reporting !== false) {
      return joe.report('finishTest', test, err);
    }
  };

  return Suite;

})(TaskGroup);

Suite.prototype.suite = Suite.prototype.describe = function() {
  var args, suite;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  suite = (function(func, args, ctor) {
    ctor.prototype = func.prototype;
    var child = new ctor, result = func.apply(child, args);
    return Object(result) === result ? result : child;
  })(Suite, args, function(){});
  return this.addGroup(suite);
};

Suite.prototype.test = Suite.prototype.it = function() {
  var args, test;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  test = (function(func, args, ctor) {
    ctor.prototype = func.prototype;
    var child = new ctor, result = func.apply(child, args);
    return Object(result) === result ? result : child;
  })(Test, args, function(){});
  return this.addTask(test);
};

Object.getOwnPropertyNames(EventEmitterGrouped.prototype).forEach(function(key) {
  return Test.prototype[key] = Suite.prototype[key] = EventEmitterGrouped.prototype[key];
});

joePrivate = {
  globalSuite: null,
  getGlobalSuite: function() {
    if (joePrivate.globalSuite == null) {
      joePrivate.globalSuite = new Suite({
        reporting: false,
        name: false
      }).run();
    }
    return joePrivate.globalSuite;
  },
  errorLogs: [],
  addErrorLog: function(errorLog) {
    var ref2;
    if (errorLog.err === ((ref2 = joePrivate.errorLogs[joePrivate.errorLogs.length - 1]) != null ? ref2.err : void 0)) {

    } else {
      joePrivate.errorLogs.push(errorLog);
    }
    return joePrivate;
  },
  exited: false,
  reporters: [],
  totalSuites: 0,
  totalPassedSuites: 0,
  totalFailedSuites: 0,
  totalTests: 0,
  totalPassedTests: 0,
  totalFailedTests: 0,
  getReporters: function() {
    var arg, argResult, err, error, i, len, ref2, reporterName;
    if (joePrivate.reporters.length === 0) {
      reporterName = 'console';
      ref2 = (typeof process !== "undefined" && process !== null ? process.argv : void 0) || [];
      for (i = 0, len = ref2.length; i < len; i++) {
        arg = ref2[i];
        argResult = arg.replace(/^--joe-reporter=/, '');
        if (argResult !== arg) {
          reporterName = argResult;
          break;
        }
      }
      try {
        joe.addReporter(reporterName);
      } catch (error) {
        err = error;
        console.error("Joe could not load the reporter: " + reporterName + "\nPerhaps it's not installed? Try install it using:\n    npm install --save-dev joe-reporter-" + reporterName + "\nThe exact error was:");
        console.error(err.stack || err.message);
        joe.exit(1);
        return;
      }
    }
    return joePrivate.reporters;
  }
};

joe = {
  getTotals: function() {
    var errorLogs, result, success, totalErrors, totalFailedSuites, totalFailedTests, totalIncompleteSuites, totalIncompleteTests, totalPassedSuites, totalPassedTests, totalSuites, totalTests;
    totalSuites = joePrivate.totalSuites, totalPassedSuites = joePrivate.totalPassedSuites, totalFailedSuites = joePrivate.totalFailedSuites, totalTests = joePrivate.totalTests, totalPassedTests = joePrivate.totalPassedTests, totalFailedTests = joePrivate.totalFailedTests, errorLogs = joePrivate.errorLogs;
    totalIncompleteSuites = totalSuites - totalPassedSuites - totalFailedSuites;
    totalIncompleteTests = totalTests - totalPassedTests - totalFailedTests;
    totalErrors = errorLogs.length;
    success = (totalIncompleteSuites === 0) && (totalFailedSuites === 0) && (totalIncompleteTests === 0) && (totalFailedTests === 0) && (totalErrors === 0);
    result = {
      totalSuites: totalSuites,
      totalPassedSuites: totalPassedSuites,
      totalFailedSuites: totalFailedSuites,
      totalIncompleteSuites: totalIncompleteSuites,
      totalTests: totalTests,
      totalPassedTests: totalPassedTests,
      totalFailedTests: totalFailedTests,
      totalIncompleteTests: totalIncompleteTests,
      totalErrors: totalErrors,
      success: success
    };
    return result;
  },
  getErrorLogs: function() {
    return joePrivate.errorLogs.slice();
  },
  hasErrors: function() {
    return joe.getTotals().success === false;
  },
  hasExited: function() {
    return joePrivate.exited === true;
  },
  hasReporters: function() {
    return joePrivate.reporters !== 0;
  },
  addReporter: function(reporterInstance) {
    var Reporter;
    if (typeof reporterInstance === 'string') {
      Reporter = require("joe-reporter-" + reporterInstance);
      reporterInstance = new Reporter();
    }
    reporterInstance.joe = joe;
    joePrivate.reporters.push(reporterInstance);
    return joe;
  },
  setReporter: function(reporterInstance) {
    joePrivate.reporters = [];
    if (reporterInstance != null) {
      joe.addReporter(reporterInstance);
    }
    return joe;
  },
  report: function() {
    var args, event, i, len, ref2, reporter, reporters;
    event = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    reporters = joePrivate.getReporters();
    if (!reporters.length) {
      console.error("Joe has no reporters loaded, so cannot log anything...");
      joe.exit(1);
      return joe;
    }
    for (i = 0, len = reporters.length; i < len; i++) {
      reporter = reporters[i];
      if ((ref2 = reporter[event]) != null) {
        ref2.apply(reporter, args);
      }
    }
    return joe;
  },
  exit: function(exitCode) {
    if (joe.hasExited()) {
      return;
    }
    joePrivate.exited = true;
    if (exitCode == null) {
      exitCode = joe.hasErrors() ? 1 : 0;
    }
    joePrivate.getGlobalSuite().destroy();
    joe.report('exit', exitCode);
    if (typeof process !== "undefined" && process !== null) {
      if (typeof process.exit === "function") {
        process.exit(exitCode);
      }
    }
    return joe;
  },
  uncaughtException: function(err) {
    if (joe.hasExited()) {
      return;
    }
    if (!util.isError(err)) {
      err = new Error(err);
    }
    joePrivate.addErrorLog({
      name: 'uncaughtException',
      err: err
    });
    joe.report('uncaughtException', err);
    joe.exit(1);
    return joe;
  },
  getItemName: function(item, separator) {
    return item.names.join(separator);
  }
};

if (typeof process !== "undefined" && process !== null) {
  if (!isWindows) {
    process.on('SIGINT', function() {
      return joe.exit();
    });
  }
  process.on('exit', function() {
    return joe.exit();
  });
  process.on('uncaughtException', function(err) {
    return joe.uncaughtException(err);
  });
}

joePrivate.getGlobalSuite().done(function(err) {
  if (err) {
    return joe.uncaughtException(err);
  }
});

joe.describe = joe.suite = function() {
  var args, globalSuite;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  globalSuite = joePrivate.getGlobalSuite();
  return globalSuite.suite.apply(globalSuite, args);
};

joe.it = joe.test = function() {
  var args, globalSuite;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  globalSuite = joePrivate.getGlobalSuite();
  return globalSuite.test.apply(globalSuite, args);
};

if (!isBrowser) {
  if (typeof Object.freeze === "function") {
    Object.freeze(joe);
  }
}

module.exports = joe;
